<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  Content.loadmodule
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

/**
 * Plug-in to enable inline editing for article and image modules into content (e.g. articles)
 *
 * @since  1.5
 */
class PlgContentARKImages extends JPlugin
{
	public $app;
	
	public static $images = array();

	/**
	 * Plugin that loads module positions within content
	 *
	 * @param   string   $context   The context of the content being passed to the plugin.
	 * @param   object   &$article  The article object.  Note $article->text is also available
	 * @param   mixed    &$params   The article params
	 * @param   integer  $page      The 'page' number
	 *
	 * @return  mixed   true if there is an error. Void otherwise.
	 *
	 * @since   1.6
	 */
	public function onContentAfterDisplay($context, &$article, &$params, $page = 0)
	{
		// Don't run this plugin when the content is being indexed
			
      
        if(!in_array($context,array('com_content.article','com_content.featured','com_content.category')))
		{
			return;
		}
		
        if(empty($article->images))
		{
			return;
		}	

		if(!$this->app->input->get('ark_inine_enabled',false))
		{
			return;
		}	


		if(is_array($params))
		{	
			$parameters = new JRegistry($params);
		}
		else
		{
			if(!empty($params)) 
				$parameters = $params;
			else
				$parameters = new JRegistry;
		}	
		
		if(!empty($parameters) && $parameters->get('inline') === true )
		{
			return;
		}
		

		$images = json_decode($article->images);
		if($context == 'com_content.article')
		{
			if(!empty($images->image_fulltext))
                static::$images[$article->id.'_full'] = htmlspecialchars($images->image_fulltext);
    	}
		else
		{
	         if(!empty($images->image_intro))
                static::$images[$article->id.'_intro'] = htmlspecialchars($images->image_intro);			
		}		

	}
}
