<?php
/**
 * @package   System - ZOO Event
 * @author    YOOtheme http://www.yootheme.com
 * @copyright Copyright (C) YOOtheme GmbH
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

	
JTable::addIncludePath(JPATH_PLUGINS.'/system/arkimages/tables'); 

class plgSystemArkImages extends JPlugin {

	public $app;
	
	/**
	 * onAfterRoute handler
	 *
	 *
	 * @access public
	 * @return null
	 */
	public function onAfterRoute()
	{
		
		//Inline editing is only enabled for frontend editing	
		if ($this->app->isAdmin())
		{
			return;
		}
		
        $user = JFactory::getUser();
		
		//if user is guest lets bail
		if($user->get('guest'))
		{
			return;
		}
			
		if($this->app->input->get('option') == 'com_contenthistory' &&  $this->app->input->get('type_alias') == 'com_content.content')
		{		
			
			$uuid = $this->app->input->get('item_id',0);
			
			if(is_int($uuid ))
				return;
			
			if(!$uuid)
				return;
		
			list($item_id,$type) = explode('_',$uuid);
			
			if(in_array($type,array('full','intro')))
			{
				$db = JFactory::getDBO();
				$query = $db->getQuery(true);
				$query->select('type_id,type_alias')
					->from('#__content_types');
				if($type == 'full')	
				{
					$query->where('type_alias = '.$db->quote('com_content_images.fullimage'));
				}
				else
				{
					$query->where('type_alias = '.$db->quote('com_content_images.introimage'));
				}	
				$db->setQuery($query);	
				$typeObj = $db->loadObject();	
				$this->app->input->set('type_id', $typeObj->type_id);
				$this->app->input->set('type_alias', $typeObj->type_alias);
			}
			elseif($this->app->input->get('option') == 'com_contenthistory' &&  
					in_array($this->app->input->get('type_alias'), array('com_content_images.fullimage','com_content_images.introimage')))
			{
				$this->app->input->set('item_id', $item_id);	
			}
		}
	}	

	
	/**
	 * onAfterDispatch handler
	 *
	 *
	 * @access public
	 * @return null
	 */
	public function onAfterDispatch()
	{
		//Inline editing is only enabled for frontend editing	
		if ($this->app->isAdmin())
		{
			return;
		}
		
        $user = JFactory::getUser();
		
		//if user is guest lets bail
		if($user->get('guest'))
		{
			return;
		}
		
		if(!$this->app->input->get('ark_inine_enabled',false))
		{
			return;
		}		
			
		if(!JPluginHelper::isEnabled('editors','arkeditor'))
        {
			return;	
		}	
		
        if(!JPluginHelper::isEnabled('system','inlinecontent'))
		{	
            return;	
		}
		
		$document = JFactory::getDocument();
		$document->addCustomTag("
		<script>
       jQuery(function()
        {
	    CKEDITOR.on( 'instanceCreated', function( evt ) {
			 var editor  = evt.editor,
			 editable = editor.element;
			 
			 if(editable.hasClass('noloadup'))
			 {
				editable.setCustomData('hasFirstFocus',true); 
			 }	 

            editor.on('beforeContentUpdate',function(event)
		    {
            
                if(!event.data.data)
                    return false;
            
                //Are there any links that need to be added to SqueezeBox
			    if( event.data.data[0].data.indexOf( 'modal' ) != -1 )
                {
                    //Has squeezebox been loaded?
                    if( typeof(SqueezeBox) === 'undefined' && !jQuery.fn.squeezeBox)
                    {
                        //Doesn't appear so, so lets call it.
		                jQuery.getScript('http://localhost:30370/media/editors/arkeditor/js/squeezebox.min.js');
					    jQuery.getScript('http://localhost:30370/media/editors/arkeditor/js/jquery.easing.min.js');
                    }

                }//end if
			
		    }, null, null, 1);
	
		}, null, null, 1);
		

        CKEDITOR.on( 'instanceReady', function( event ) 
	    {
            var editor  = event.editor,
			editable = editor.editable();
            
            CKEDITOR.env.gecko && editor.editable().attachListener( editor.editable(), 'mouseup', function(evt) {
				var element = evt.data.getTarget();
    
				if(element)
				{

                    if(element.is('img'))
				    {
                        editor.focusManager.focus();
						var selection = editor.getSelection();
						selection.selectElement(element);
				     }
				 }
			  });
		    
        

        })
      });   
       </script>");
	}

	
	/**
	 * onAfterRender handler
	 *
	 *
	 * @access public
	 * @return null
	 */
	
	public function onAfterRender() {

		//Inline editing is only enabled for frontend editing	
		if ($this->app->isAdmin())
		{
			return;
		}
		
        $user = JFactory::getUser();
		
		//if user is guest lets bail
		if($user->get('guest'))
		{
			return;
		}
		
       	if(!$this->app->input->get('ark_inine_enabled',false))
		{
			return;
		}		
			

		if(!JPluginHelper::isEnabled('editors','arkeditor'))
        {
			return;	
		}	
		
        if(!JPluginHelper::isEnabled('system','inlinecontent'))
		{	
            return;	
		}
		

		if(!class_exists('PlgContentARKImages') || empty(PlgContentARKImages::$images))	
		{
			return;	
		}	
		
		// Get the response body
        $body = $this->app->getBody();

        $base   = JUri::base(true) . '/';
        if($this->app->get('sef', '0') == '0')
            $base ='';
        
  		
		foreach (PlgContentARKImages::$images as $id => $path)
		{
			
            $path2 = str_replace('.','\.',$base.$path);

            $path1 = str_replace('.','\.',$path);

            $body = preg_replace_callback('#<img[^<>]+src=["\']('.$path1.'|'.$path2.')["\'][^<>]*>#',
				function($matches) use ($id){
					$match = $matches[0];

                    return '<div 
                            data-id="'.$id.'" 
                            data-context="article" 
                            data-type="body" 
                            data-itemtype="image" 
                            class="editable noloadup" 
                            style="display:inline;" 
                            contenteditable="true">'.
                            $match.
                            '</div>'; 
				}, 
				$body, 
				1
			);
            			
		}
	
		$this->app->setBody($body);
	}
}
