<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark inline content Article Context Class
 *
 * @package     Inlinecontent.Contexts
 * @subpackage  Inlinecontent.contexts.image
 */

class ARKContextsArticleImage extends ARKContextsArticleArticle
{
	
	protected $type;
	
	
	public function __construct($id)
	{
		
        list($id, $type) = explode('_',$id);
		$this->type = $type;
		parent::__construct($id);
		$this->table->images = json_decode($this->table->images,true);
	}
	
	
    public function get()
	{
		
		return array( 'title'=>'','data'=>'');	

	}
	
	
	
	public function triggerContentPlugins($rawText)
	{
		return array( 'data'=>$rawText);
	}
			
	public function save($data,$type = 'body')
	{
		if($this->id == null)
			return array( 'title'=>'','data'=>'');	
		
		$img = base64_decode($data['articletext']);
		
		$dom = new DOMDocument();
		$dom->strictErrorChecking = false;
		$dom->recover = true;
		$dom->loadHTML('<div>'.$img.'</div>');
	
		$images = $dom->getElementsByTagName('img');
		$image = $images->item(0);
		$src = $image->getAttribute('src');
		$path = str_replace(JURI::base(),'',$src);
		
		
		$images = $this->table->images;
		
		if($this->type == 'intro')
		{
			$images['image_intro'] = $path;
		}	
		else
		{
			$images['image_fulltext'] = $path;
		}	
		
        //remove articletext element from array
        unset($data['articletext']);

		$this->table->images = json_encode($images);
		$this->table->save($data);
		
		
		//save version
		$dataObject = new stdclass;
		
		$dataObject->id =  $this->id;
        $dataObject->image = $img;
		$dataObject->name = 'Article Full Image';
		
		$typeAlias = 'com_content_images.fullimage';
		if($this->type == 'intro')
		{
			$typeAlias = 'com_content_images.introimage';
			$dataObject->name = 'Article Intro Image';
		}	
		
		$historyTable = JTable::getInstance('Contenthistory', 'JTable');
		$typeTable = JTable::getInstance('Contenttype', 'JTable');
		$typeTable->load(array('type_alias' => $typeAlias ));
		$historyTable->set('ucm_type_id', $typeTable->type_id);

		$historyTable->set('ucm_item_id', $dataObject->id);

		// Don't store unless we have a non-zero item id
		if ($historyTable->ucm_item_id)
		{
			$historyTable->set('version_data', json_encode($dataObject));
			$historyTable->set('sha1_hash', $historyTable->getSha1($dataObject, $typeTable));

            if ($historyRow = $historyTable->getHashMatch())
                $historyTable->set('version_id', $historyRow->version_id);
                

			$result = $historyTable->store();

			// Load history_limit config from extension.
			$aliasParts = explode('.', $typeAlias);

			if ($maxVersions = JComponentHelper::getParams($aliasParts[0])->get('history_limit', 0))
			{
				$historyTable->deleteOldVersions($maxVersions);
			}

		}
												
		return array( 'title'=>'','data'=>$img,'message'=>'Please note that only the image path will be saved');	
	}
	
	public function version($versionId,$type)
	{
				
        $historyTable = JTable::getInstance('Contenthistory');
		$historyTable->load($versionId);
   
		$rowArray = JArrayHelper::fromObject(json_decode($historyTable->version_data));

		$item = JTable::getInstance('image','ContentTable');

		$item->bind($rowArray);		
        
		return array( 'data'=>$item->image);
	}
	
}